// DiskEraser.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <wincrypt.h>
#include <time.h>


//LPCTSTR GetRandomFilename()
//{
//	srand((unsigned) time(0) * rand());
//	TCHAR randomname[13];
//	for (int i = 0; i < 11; i++)
//	{
//		int pos = i + (i >= 8 ? 1 : 0);
//		randomname[pos] = ((double) rand() / (double) RAND_MAX) * 36 + 'A';
//		if (randomname[pos] > 'Z')
//		{
//			randomname[pos] -= ('Z' + 1) - '0';
//		}
//	}
//	randomname[8] = '.';
//	randomname[12] = 0;
//	return randomname;
//}

// Each file is 36 MB large
int filesize = 36 * 1024 * 1024;

int CreateRandomFile(LPCTSTR path, int data)
{
	if (data < 0 || data > 2) return 4;

	// Require at least 10 kB free disk space to continue
	int minimumsize = 10 * 1024;
	// Generate 18 MB of random numbers per file
	int patternsize = 18 * 1024 * 1024;
	// Repeat the pattern 2 times over the file (This is filesize / patternsize)
	int patterncount = 2;

	//TCHAR filename[] = TEXT("C:\\random.tmp");   // Test
	TCHAR filename[MAX_PATH];
	_tcscpy(filename, path);
	_tcscat(filename, TEXT(":\\"));

	ULARGE_INTEGER liAvail, liTotal;
	GetDiskFreeSpaceEx(filename, &liAvail, &liTotal, NULL);
	if (liAvail.QuadPart < minimumsize)
	{
		printf("\nNo disk space available.\n");
		return 1;
	}
	if (liAvail.QuadPart < filesize)
	{
		filesize = liAvail.QuadPart;
		patternsize = filesize;
		patterncount = 1;
	}
	
	HANDLE hFile;
	do
	{
		_tcscpy(filename, path);
		_tcscat(filename, TEXT(":\\"));
//		LPCTSTR randomname = GetRandomFilename();
		// BEGIN GetRandomFilename - returning the value doesn't work in a Release build
		srand((unsigned) time(0) * rand());
		TCHAR randomname[13];
		for (int i = 0; i < 11; i++)
		{
			int pos = i + (i >= 8 ? 1 : 0);
			randomname[pos] = ((double) rand() / (double) RAND_MAX) * 36 + 'A';
			if (randomname[pos] > 'Z')
			{
				randomname[pos] -= ('Z' + 1) - '0';
			}
		}
		randomname[8] = '.';
		randomname[12] = 0;
		// END GetRandomFilename
		_tcsncat(filename, randomname, 12);

		hFile = CreateFile(
			filename,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ,
			NULL,
			CREATE_NEW,
			FILE_ATTRIBUTE_NORMAL | FILE_FLAG_NO_BUFFERING | FILE_FLAG_OVERLAPPED,
			NULL);
	}
	while (hFile == INVALID_HANDLE_VALUE && GetLastError() == ERROR_ALREADY_EXISTS);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		DWORD dwErr = GetLastError();
		printf("\nCannot create file. Error %lu\n", dwErr);
		return 2;
	}

	SetFilePointer(hFile, filesize, NULL, FILE_BEGIN);
	SetEndOfFile(hFile);
	HANDLE hMap = CreateFileMapping(
		hFile,
		NULL,
		PAGE_READWRITE,
		0,
		0,
		NULL);
	if (hMap == NULL)
	{
		DWORD dwErr = GetLastError();
		printf("\nCannot create file mapping. Error %lu\n", dwErr);
		return 3;
	}
	LPBYTE pBuf = (LPBYTE) MapViewOfFile(
		hMap,
		FILE_MAP_WRITE,
		0,
		0,
		0);
	if (pBuf == NULL)
	{
		DWORD dwErr = GetLastError();
		printf("\nCannot map file into memory. Error %lu\n", dwErr);
		return 3;
	}

	unsigned int seed = 0;
	
	if (data == 0)
	{
		// Set all bits to 0
		//FillMemory(pBuf, filesize, 0);   // Slower
		for (int pos = 0; pos < filesize; pos++)
		{
			pBuf[pos] = 0;
		}
	}
	else if (data == 1)
	{
		// Set all bits to 1
		//FillMemory(pBuf, filesize, 0xFF);   // Slower
		for (int pos = 0; pos < filesize; pos++)
		{
			pBuf[pos] = 0xFF;
		}
	}
	else if (data == 2)
	{
		// Write random data
		HCRYPTPROV hCryptProv;
		CryptAcquireContext(
			&hCryptProv,
			NULL,
			NULL,
			PROV_RSA_FULL,
			CRYPT_VERIFYCONTEXT);
		//CryptGenRandom(
		//	hCryptProv,
		//	filesize,
		//	(BYTE *) pBuf);   // Use real random data from the Crypto API for the entire file - slower
		CryptGenRandom(
			hCryptProv,
			sizeof(int),
			(LPBYTE) &seed);   // Only use a 4-byte seed from the Crypto API and get random numbers from the C runtime
		CryptReleaseContext(hCryptProv, 0);
		
		srand(seed);
		for (int pos = 0; pos < patternsize; pos++)
		{
			//register BYTE b = ((double) rand() / (double) RAND_MAX) * 255;
			register BYTE b = rand() / (RAND_MAX / 255);   // Faster, only using integer precision

			pBuf[pos] = b;
			if (patterncount == 2)
				pBuf[pos + patternsize] = b;

			//if (patterncount >= 2)
			//	pBuf[pos + patternsize] = b;
			//if (patterncount >= 3)
			//	pBuf[pos + 2 * patternsize] = b;

			// Generic method, works for all patterncount values
			//for (int i = 1; i < patterncount; i++)
			//{
			//	pBuf[pos + i * patternsize] = pBuf[pos];
			//}
		}
	}

	//CopyMemory((PVOID) pBuf, TEXT("Hallo Welt\r\n"), 12);   // Test

	UnmapViewOfFile(pBuf);
	//FlushFileBuffers(hFile);
	CloseHandle(hFile);

	return 0;
}

int _tmain(int argc, _TCHAR* argv[])
{
	if (argc != 3 ||
		_tcslen(argv[1]) != 1 ||
		argv[1][0] < 'A' ||
		argv[1][0] > 'Z' && argv[1][0] < 'a' ||
		argv[1][0] > 'z' ||
		_tstoi(argv[2]) < 0 ||
		_tstoi(argv[2]) > 2)
	{
		printf("Usage: DiskEraser <DriveLetter> <WriteMode>\n");
		printf("\n");
		printf("DriveLetter: A, B, C, etc. without the ':' character\n");
		printf("WriteMode: 0 writes all zeroes, 1 writes all ones, 2 writes random data\n");
		return -1;
	}
	
	int ret;
	const int rates_count = 20;
	double rates[rates_count];
	for (int i = 0; i < rates_count; i++)
		rates[i] = 0;

	TCHAR path[MAX_PATH];
	_tcscpy(path, argv[1]);
	_tcscat(path, TEXT(":\\"));

	printf("DiskEraser (c) Yves Goergen, http://beta.unclassified.de\n\n", path);
	printf("Creating files in %S\n\n", path);
	printf("Press Control+C to cancel. Be sure to delete the\nlatest written file because it will be incomplete.\n\n");
	
	printf("Write rate   Progress  Remaining time\n");
	while (true)
	{
		DWORD ticks0 = GetTickCount();
		ret = CreateRandomFile(argv[1], _tstoi(argv[2]));
		if (ret) break;
		DWORD ticks1 = GetTickCount();
		for (int i = rates_count - 1; i > 0; i--)
			rates[i] = rates[i - 1];
		rates[0] = (double) filesize / (1024 * 1024) * 1000 / (double) (ticks1 - ticks0);
		if (rates[1] == 0)
		{
			// Spread the first sample over all slots to get a good average immediately
			for (int i = 1; i < rates_count; i++)
				rates[i] = rates[i - 1];
		}
		double avg = 0;
		for (int i = 0; i < rates_count; i++)
			avg += rates[i];
		avg /= rates_count;
		
		ULARGE_INTEGER liAvail, liTotal;
		GetDiskFreeSpaceEx(path, &liAvail, &liTotal, NULL);
		double progress = ((double) liTotal.QuadPart - (double) liAvail.QuadPart) / (double) liTotal.QuadPart * 100;

		double remtime = (double) liAvail.QuadPart / (1024 * 1024) / avg / 60;

		for (int j = 0; j < 32; j++)
			printf("\b");
		printf("%5.1f MB/s \xFA %5.1f %% \xFA %5.0f min", avg, progress, remtime);
	}
	//printf("\nExited with code %d\n", ret);
	return ret;
}
